/*
PRICE was written by Graham Ruby.
This file is part of PRICE.

PRICE is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

PRICE is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with PRICE.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef OUTPUTFILE_CPP
#define OUTPUTFILE_CPP

#include "OutputFile.h"
#include "AssemblyException.h"
#include "ReadFile.h"
#include "OutputFileFasta.h"
#include "OutputFilePriceq.h"

OutputFile::~OutputFile(){};

OutputFile* OutputFile::makeOutputFile(string filename){
  ReadFile::FileType fileType = ReadFile::getFileType(filename);
  if (fileType == ReadFile::PRICEQFILE){
    return new OutputFilePriceq( filename );
  } else if (fileType == ReadFile::FASTAFILE){
    return new OutputFileFasta( filename );
  } else {
    throw AssemblyException::ArgError("output filenames must be fasta or priceq");
  }
}


#endif
